package com.ruoyi.system.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.system.domain.VersionInfo;
import com.ruoyi.system.domain.vo.VersionUpdateVo;
import com.ruoyi.system.service.IVersionInfoService;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.web.bind.annotation.*;

/**
 * 版本信息的CURD
 */

@RestController
@RequestMapping("/system/version")
public class TVersionInfoController extends BaseController
{

    @Autowired
    IVersionInfoService versionInfoService;

    @RequestMapping(value = "addVersion")
    public AjaxResult insertVersion( VersionInfo versionInfo){
        versionInfo.setCreatBy(SecurityUtils.getUsername());
        if (versionInfo.getVersionType()==0){
            if (versionInfo.getStallList().isEmpty()){
                return AjaxResult.error("灰度测试下，测试摊位号不能为空！");
            }
            if (versionInfo.getStallList()!=null){
                if (versionInfo.getStallList().contains("，")){
                    return AjaxResult.error("请输入半角逗号！");
                }
                String stallList=","+versionInfo.getStallList()+",";
                versionInfo.setStallList(stallList);
            }
        }
        int version=versionInfoService.insertVersionNum(versionInfo);

        if(version==1){
            return AjaxResult.success("新增成功！");
        }
        return AjaxResult.error("新增失败，版本号低于目前的版本");

    }

    @GetMapping(value = "selectNum")
    public AjaxResult selectNum(VersionInfo versionInfo){
        return AjaxResult.success(versionInfoService.selectVersionNum(versionInfo));

    }

    @GetMapping(value = "selectLast")
    public AjaxResult selectLast(){
        return AjaxResult.success(versionInfoService.selectLastNum());

    }

    @DeleteMapping(value = "deleteInfo")
    public AjaxResult deleteInfo(@RequestParam Long id){
        if(id==null){
            AjaxResult.error("id不能为空");
        }
        VersionInfo versionInfo=versionInfoService.selectById(id);
        if( versionInfo==null ){
            return  AjaxResult.error("删除失败，此版本已不存在");
        }



        return toAjax(versionInfoService.deleteVersionNum(id));

    }

    @GetMapping(value = "list")
    public AjaxResult listVersion(){
        return AjaxResult.success(versionInfoService.listVersion());
    }

    /**
     *
     * 版本获取1
     */
    @GetMapping(value = "update")
    public AjaxResult updateTvVersion(String stallNumber,Integer versionNum){

        VersionUpdateVo versionUpdateVo=versionInfoService.updateTvVersion(stallNumber,versionNum);

        return AjaxResult.success(versionUpdateVo);
    }

    /**
     *
     * 版本获取2
     */

    @GetMapping(value = "getVersion")
    public AjaxResult getLatestTvVersion(String stallNumber,Integer versionNum){

        VersionInfo versionInfo=versionInfoService.gerLatestTvVersion(stallNumber,versionNum);
        if (versionInfo==null){
            return AjaxResult.error();
        }

        return AjaxResult.success(versionInfo);
    }

    /**
     *
     * 修改
     */
    @RequestMapping(value = "modify")
    public AjaxResult modifyVersion(VersionInfo versionInfo){
        if (versionInfo.getVersionType()==null && versionInfo.getStallList()==null){
            return AjaxResult.error("修改内容不能为空！");
        }
        if (versionInfo.getStallList().isEmpty()==false){
            if (versionInfo.getStallList().contains("，")){
                return AjaxResult.error("请输入半角逗号");
            }
            String stallList=","+versionInfo.getStallList()+",";
            versionInfo.setStallList(stallList);
        }
        return toAjax(versionInfoService.modifyVersion(versionInfo));
    }

    @GetMapping(value = "selectById")
    public AjaxResult selectById(Long id){
        if (id==null){
            AjaxResult.error("id不能为空！");
        }
        return AjaxResult.success(versionInfoService.selectById(id));
    }


}
