package com.ruoyi.system.service.impl;


import com.ruoyi.system.domain.VersionInfo;
import com.ruoyi.system.domain.vo.VersionUpdateVo;
import com.ruoyi.system.mapper.VersionInfoMapper;
import com.ruoyi.system.service.IVersionInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class TVersionInfoImpl implements IVersionInfoService {

    @Autowired
    VersionInfoMapper versionInfoMapper;




    @Override
    public int insertVersionNum(VersionInfo versionInfo) {
        VersionInfo versionInfo1=selectLastNum();
        if (versionInfo.getVersionNum() > versionInfo1.getVersionNum() )
        {
        return versionInfoMapper.insertVersionNum(versionInfo);
        }
        return 0;

    }

    @Override
    public List<VersionInfo> selectVersionNum(VersionInfo versionInfo) {
        return versionInfoMapper.selectVersionNum(versionInfo);
    }

    @Override
    public VersionInfo selectLastNum() {
        VersionInfo versionInfo=versionInfoMapper.selectLastNum();
        if (versionInfo==null){
            versionInfo = new VersionInfo();
            versionInfo.setVersionNum(-1);
            versionInfo.setVersionType(1);
            return versionInfo;
        }
        return versionInfo;
    }

    @Override
    public int deleteVersionNum(Long id) {
        return versionInfoMapper.deleteVersionNum(id);
    }

    @Override
    public List<VersionInfo> listVersion() {
        return versionInfoMapper.listVersion();
    }

    @Override
    public VersionInfo selectById(Long id) {
        return versionInfoMapper.selectById(id);
    }

    @Override
    public VersionUpdateVo updateTvVersion(String stallNumber, Integer versionNum) {
        VersionInfo versionInfo=selectLastNum();
        VersionUpdateVo versionUpdateVo=new VersionUpdateVo();

        if (versionNum<versionInfo.getVersionNum()){

            if(versionInfo.getVersionType()==0){

                if (versionInfo.getStallList().contains(","+stallNumber+",")){
                    versionUpdateVo.setUpdate(1);
                    versionUpdateVo.setVersionNum(versionInfo.getVersionNum());
                    versionUpdateVo.setUpdateType(0);
                    versionUpdateVo.setAddress(versionInfo.getUrl());
                    return versionUpdateVo;
                }
                versionUpdateVo.setUpdateType(1);
                return versionUpdateVo;
            }
            else if (versionInfo.getVersionType()==1){
                versionUpdateVo.setUpdate(1);
                versionUpdateVo.setVersionNum(versionInfo.getVersionNum());
                versionUpdateVo.setAddress(versionInfo.getUrl());
                versionUpdateVo.setUpdateType(1);
                versionUpdateVo.setAddress(versionInfo.getUrl());
                return versionUpdateVo;
            }

        }
        versionUpdateVo.setUpdate(0);
        versionUpdateVo.setUpdateType(2);
        versionUpdateVo.setVersionNum(0);
        versionUpdateVo.setAddress("");
        return versionUpdateVo;
    }

    @Override
    public VersionInfo gerLatestTvVersion(String stallNumber, Integer versionNum) {
        VersionInfo versionInfo=selectLastNum();
        if (versionNum<versionInfo.getVersionNum()){

            if (versionInfo.getVersionType().equals(0)){

                if (versionInfo.getStallList().contains(","+stallNumber+",")){
                    return versionInfo;
                }
                return null;
            }
             else if (versionInfo.getVersionType().equals(1)){
                 return versionInfo;
            }
             return null;
        }
        return null;
    }

    @Override
    public int modifyVersion(VersionInfo versionInfo) {
        return versionInfoMapper.modifyVersion(versionInfo);
    }
}
